const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const validation_rule_sets = sequelize.define(
    'validation_rule_sets',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

is_default: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  validation_rule_sets.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














    db.validation_rule_sets.hasMany(db.validation_rules, {
      as: 'validation_rules_rule_set',
      foreignKey: {
          name: 'rule_setId',
      },
      constraints: false,
    });











//end loop



    db.validation_rule_sets.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.validation_rule_sets.belongsTo(db.data_entities, {
      as: 'data_entity',
      foreignKey: {
        name: 'data_entityId',
      },
      constraints: false,
    });

    db.validation_rule_sets.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.validation_rule_sets.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.validation_rule_sets.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return validation_rule_sets;
};


